<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcEvolve Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcEvolve Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcEvolve" --><!-- doxytag: inherits="iBase" -->
<p>A property class implementing a genetic algorithm.  
 <a href="structiPcEvolve.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="evolve_8h_source.html">propclass/evolve.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcEvolve:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcEvolve.png" usemap="#iPcEvolve_map" alt=""/>
  <map id="iPcEvolve_map" name="iPcEvolve_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,69,24"/>
</map>
 </div></div>

<p><a href="structiPcEvolve-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcEvolve.html#a7f3d8ff4fb2d4628b75198901a1f9ff2">FitnessCallback</a> (float fitness)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Informs the property class that the fitness of a genome has been evaluated, as requested by the "pcevolve_fitness" message.  <a href="#a7f3d8ff4fb2d4628b75198901a1f9ff2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcEvolve.html#a3741ab18728799a707f8c9d0ef659733">Generate</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Instructs the property class to begin the evolution of one generation.  <a href="#a3741ab18728799a707f8c9d0ef659733"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcEvolve.html#a59b45cecc3d2f4a44f372c02669a36cd">GetFitness</a> (size_t index) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the fitness of the genome specified by the index parameter.  <a href="#a59b45cecc3d2f4a44f372c02669a36cd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcEvolve.html#ae21546b6edf6d377cc36e6c93dfddee3">GetPopulationSize</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the population size (number of individual genomes).  <a href="#ae21546b6edf6d377cc36e6c93dfddee3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelPropertyClass.html">iCelPropertyClass</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcEvolve.html#a4a5d3882ec4820f5baa094932f68d95c">GetSubject</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the subject property class (the property class being evolved by this one.  <a href="#a4a5d3882ec4820f5baa094932f68d95c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcEvolve.html#a7a19501d4d49ad74ca71910917a8465c">ResetPopulation</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Resets the property class to its initial state before <a class="el" href="structiPcEvolve.html#a3741ab18728799a707f8c9d0ef659733" title="Instructs the property class to begin the evolution of one generation.">Generate()</a> was first called.  <a href="#a7a19501d4d49ad74ca71910917a8465c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcEvolve.html#a5128dd26715355a025b0558d24ae44fe">SelectGenome</a> (size_t index)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Stored the genome specified by the index parameter into the subject property class.  <a href="#a5128dd26715355a025b0558d24ae44fe"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcEvolve.html#a71d414b94496d2d86b8c72ebbb6e5ad9">SetPopulationSize</a> (size_t size)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the population size (number of individual genomes).  <a href="#a71d414b94496d2d86b8c72ebbb6e5ad9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcEvolve.html#ab634e24030ad6811b07c010dd2d2dc8a">SetProbabilities</a> (float select, float mutate)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the probability parameters for the stochastic (non-deterministic) randomness of the genetic algorithm.  <a href="#ab634e24030ad6811b07c010dd2d2dc8a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcEvolve.html#a51b65994a43befc0dd0b4aa968fc98dd">SetSubject</a> (<a class="el" href="structiCelPropertyClass.html">iCelPropertyClass</a> *pc)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the subject property class (the property class that will be evolved by this one).  <a href="#a51b65994a43befc0dd0b4aa968fc98dd"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A property class implementing a genetic algorithm. </p>
<p>Currently the only thing that can be evolved using this is the celPcNeuralNet, but it would be fairly easy to extend it to support evolving other property classes where applicable.</p>
<p>The property class holds the following properties:</p>
<ul>
<li>"population" (long) The size of the population (number of genomes).</li>
<li>"subject" (propclass) The property class that will be evolved.</li>
<li>"select_probability" (float) Parameter for stochastic selection.</li>
<li>"mutate_probability" (float) Parameter for stochastic mutation.</li>
</ul>
<p>This property class supports the following actions (add prefix 'cel.evolve.action.' if you want to access this action through a message):</p>
<ul>
<li>"Generate" Begins evolution of one generation.</li>
<li>"ReturnFitness" The behaviour calls this after evaluating the fitness of the presently selected genome. Parameter: "fitness" (float).</li>
<li>"GetFitness" Gets the fitness of a genome. Parameter: "index" (long).</li>
<li>"Select" Stores a genome in subject. Parameter: "index" (long).</li>
<li>"Reset" Resets the population to its state before "Generate" was called.</li>
</ul>
<p>And sends the following message to the behaviour:</p>
<ul>
<li>"pcevolve_fitness" Tells the behaviour to evaluate the fitness of the genome currently stored in the subject propclass.</li>
<li>"pcevolve_result" Signals completion of evolution of one generation. Parameters: "max_fitness", "min_fitness", "avg_fitness" (floats). </li>
</ul>

<p>Definition at line <a class="el" href="evolve_8h_source.html#l00061">61</a> of file <a class="el" href="evolve_8h_source.html">evolve.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a7f3d8ff4fb2d4628b75198901a1f9ff2"></a><!-- doxytag: member="iPcEvolve::FitnessCallback" ref="a7f3d8ff4fb2d4628b75198901a1f9ff2" args="(float fitness)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcEvolve.html#a7f3d8ff4fb2d4628b75198901a1f9ff2">iPcEvolve::FitnessCallback</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>fitness</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Informs the property class that the fitness of a genome has been evaluated, as requested by the "pcevolve_fitness" message. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">fitness</td><td>The fitness value. May not be less than zero. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3741ab18728799a707f8c9d0ef659733"></a><!-- doxytag: member="iPcEvolve::Generate" ref="a3741ab18728799a707f8c9d0ef659733" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcEvolve.html#a3741ab18728799a707f8c9d0ef659733">iPcEvolve::Generate</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Instructs the property class to begin the evolution of one generation. </p>
<p>This will send the "pcevolve_fitness" message once for each individual genome in the population, to ask the behaviour to evaluate its fitness. </p>

</div>
</div>
<a class="anchor" id="a59b45cecc3d2f4a44f372c02669a36cd"></a><!-- doxytag: member="iPcEvolve::GetFitness" ref="a59b45cecc3d2f4a44f372c02669a36cd" args="(size_t index) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcEvolve.html#a59b45cecc3d2f4a44f372c02669a36cd">iPcEvolve::GetFitness</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the fitness of the genome specified by the index parameter. </p>
<p>This will be zero if its fitness has yet to be evaluated. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">index</td><td>The index into the population array, which is sorted in descending order of fitness (0 being the fittest). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae21546b6edf6d377cc36e6c93dfddee3"></a><!-- doxytag: member="iPcEvolve::GetPopulationSize" ref="ae21546b6edf6d377cc36e6c93dfddee3" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t <a class="el" href="structiPcEvolve.html#ae21546b6edf6d377cc36e6c93dfddee3">iPcEvolve::GetPopulationSize</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the population size (number of individual genomes). </p>

</div>
</div>
<a class="anchor" id="a4a5d3882ec4820f5baa094932f68d95c"></a><!-- doxytag: member="iPcEvolve::GetSubject" ref="a4a5d3882ec4820f5baa094932f68d95c" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelPropertyClass.html">iCelPropertyClass</a>* <a class="el" href="structiPcEvolve.html#a4a5d3882ec4820f5baa094932f68d95c">iPcEvolve::GetSubject</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the subject property class (the property class being evolved by this one. </p>

</div>
</div>
<a class="anchor" id="a7a19501d4d49ad74ca71910917a8465c"></a><!-- doxytag: member="iPcEvolve::ResetPopulation" ref="a7a19501d4d49ad74ca71910917a8465c" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcEvolve.html#a7a19501d4d49ad74ca71910917a8465c">iPcEvolve::ResetPopulation</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Resets the property class to its initial state before <a class="el" href="structiPcEvolve.html#a3741ab18728799a707f8c9d0ef659733" title="Instructs the property class to begin the evolution of one generation.">Generate()</a> was first called. </p>

</div>
</div>
<a class="anchor" id="a5128dd26715355a025b0558d24ae44fe"></a><!-- doxytag: member="iPcEvolve::SelectGenome" ref="a5128dd26715355a025b0558d24ae44fe" args="(size_t index)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcEvolve.html#a5128dd26715355a025b0558d24ae44fe">iPcEvolve::SelectGenome</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Stored the genome specified by the index parameter into the subject property class. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">index</td><td>The index into the population array, which is sorted in descending order of fitness (0 being the fittest). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a71d414b94496d2d86b8c72ebbb6e5ad9"></a><!-- doxytag: member="iPcEvolve::SetPopulationSize" ref="a71d414b94496d2d86b8c72ebbb6e5ad9" args="(size_t size)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcEvolve.html#a71d414b94496d2d86b8c72ebbb6e5ad9">iPcEvolve::SetPopulationSize</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the population size (number of individual genomes). </p>

</div>
</div>
<a class="anchor" id="ab634e24030ad6811b07c010dd2d2dc8a"></a><!-- doxytag: member="iPcEvolve::SetProbabilities" ref="ab634e24030ad6811b07c010dd2d2dc8a" args="(float select, float mutate)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcEvolve.html#ab634e24030ad6811b07c010dd2d2dc8a">iPcEvolve::SetProbabilities</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>select</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>mutate</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the probability parameters for the stochastic (non-deterministic) randomness of the genetic algorithm. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">select</td><td>Genomes will be selected for crossover with a probability of <code>p(1-p)^r</code>, where p is this parameter and r is the genome's rank in descending order of fitness (0 being the fittest). </td></tr>
    <tr><td class="paramname">mutate</td><td>The average number of genes to mutate in each genome. For example, 3.0 means that an average of 3 genes will be mutated, while 0.5 means that one gene will be mutated in every 2 genomes, on average. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a51b65994a43befc0dd0b4aa968fc98dd"></a><!-- doxytag: member="iPcEvolve::SetSubject" ref="a51b65994a43befc0dd0b4aa968fc98dd" args="(iCelPropertyClass *pc)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcEvolve.html#a51b65994a43befc0dd0b4aa968fc98dd">iPcEvolve::SetSubject</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelPropertyClass.html">iCelPropertyClass</a> *&#160;</td>
          <td class="paramname"><em>pc</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the subject property class (the property class that will be evolved by this one). </p>
<p>It must be of a type supported by the genetic algorithm. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="evolve_8h_source.html">evolve.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
